<template>
	<list-search @searchData="searchData" @clearData="clearData" :search_params="commomParams.search"></list-search>
	<a-c-operation @refresh="clearData">
	</a-c-operation>
	<a-c-table :data="commomParams.table.data" :columns="commomParams.table.columns" :pagination="commomParams.page"
		@page="getPage" :loading="loading" childrenName="children">
		<template #default="{ record }">
			<a-row :gutter="10">
				<a-col><a-button type="primary" size="small" primary @click="edit(record)">编辑</a-button></a-col>
				<a-col><a-button type="primary" size="small" primary
						@click="addLevel(record)">添加子级</a-button></a-col>
			<a-popconfirm title="是否删除该子级?" @confirm="del(record.id)">
				<a-col><a-button v-if="record.parent_id != -1" type="primary" size="small" danger>删除</a-button></a-col>
			</a-popconfirm>
			</a-row>
		</template>
	</a-c-table>
	<list-add :edit_record="edit_record" :level_record="level_record" @successAdd="successAdd"
		@closeAdd="closeAdd"></list-add>
</template>
	
<script lang="ts" setup>
	import { ref, onMounted, watch, computed } from 'vue';
	import ListSearch from '@/views/dictionary/list/search/index.vue';
	import ListAdd from '@/views/dictionary/list/add/add.vue';
	import { GetDictList, GetDictDetail, PostDictDel } from '@/apis/models';
	import { useCommon } from '@/hooks/useCommon';
	import { cols } from '@/views/dictionary/list/columns';
	let { store, commomParams, showModal, showOtherModal1, message } = useCommon();
	let loading = ref<Boolean>(true);
	onMounted(() => {
		commomParams.value.search.show_childs = true;
		commomParams.value.search.parent_id = -1;
		getData(commomParams.value.search);
	})

	const searchData = (data : object) => {
		commomParams.value.search = data
		getData();
	}

	const clearData = (data : object) => {
		if (data) {
			commomParams.value.search = data
		} else {
			commomParams.value.search = {
				page: 1,
				pagesize: 10,
				sort: 'id',
				sortby: 'asc',
				keyword: '',
				parent_id: -1,
				show_childs: true
			}
		}
		getData();
	}


	const getPage = (data : object) => {
		commomParams.value.search.page = data.current;
		commomParams.value.search.pagesize = data.pageSize;
		getData();
	}
	const getData = async () => {
		try {
			loading.value = true;
			let res = await GetDictList(commomParams.value.search);
			loading.value = false;
			commomParams.value.table.data = res.data.dicts;
			commomParams.value.table.columns = cols;
			commomParams.value.page = {
				current: commomParams.value.search.page,
				pageSize: commomParams.value.search.pagesize,
				total: res.data.total,
				pageSizeOptions: ['10', '20', '30', '40'],
				hideOnSinglePage: false,
				showSizeChanger: true
			};
		} catch {
			loading.value = false;
		}
	}
	
	// 编辑
	let edit_record = ref<Object>(null)
	const edit = (record : object) => {
		edit_record.value = record;
		showModal()
	}
	// 添加下级
	let level_record = ref<Object>(null)
	const addLevel = (record) => {
		level_record.value = record;
		showModal()
	}
	const successAdd = () => {
		getData();
	}
	const closeAdd = () => {
		edit_record.value = null;
	}


	// 删除
	const del = (id : number) => {
		commomParams.value.delRecord = { id: id };
		PostDictDel(commomParams.value.delRecord).then(res => {
			message.success('删除成功');
			getData();
		})
	}
	

</script>

<style lang="less" scoped>

</style>